// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/components/display/Camera.hpp"
#include "display/TextureRenderTarget.hpp"

namespace Dawn {
  class CameraTexture : public SceneItemComponent {
    protected:
      std::function<void()> teardown;

      void updateOrthoValues();

    public:
      // @optional
      StateProperty<Camera*> camera;

      // @optional
      StateProperty<bool_t> updateOrtho;

      TextureRenderTarget renderTarget;

      CameraTexture(SceneItem *item);

      void onStart() override;
  };
}